package edu.uiuc.ncsa.security.delegation.client.server;

import edu.uiuc.ncsa.security.delegation.client.request.AccessTokenRequest;
import edu.uiuc.ncsa.security.delegation.client.request.AccessTokenResponse;
import edu.uiuc.ncsa.security.delegation.client.request.AuthorizationGrantRequest;
import edu.uiuc.ncsa.security.delegation.client.request.AuthorizationGrantResponse;
import edu.uiuc.ncsa.security.delegation.services.AddressableServer;
import edu.uiuc.ncsa.security.delegation.services.Request;
import edu.uiuc.ncsa.security.delegation.services.Response;

import java.net.URI;

/**
 * The authorization server, which, depending on the control flow, might be tasked with
 * granting authorization too.
 * <p>Created by Jeff Gaynor<br>
 * on Mar 11, 2011 at  4:09:45 PM
 */
public abstract class AuthorizationServer implements AddressableServer {
    protected AuthorizationServer(URI address) {
        this.address = address;
    }

    public Response process(Request request) {
        return request.process(this);
    }

    public URI getAddress() {
        return address;
    }

    URI address;

    public abstract AuthorizationGrantResponse processAGRequest(AuthorizationGrantRequest acRequest);

    public abstract AccessTokenResponse processATRequest(AccessTokenRequest atRequest);
}
