package edu.uiuc.ncsa.security.delegation.client.server;

import edu.uiuc.ncsa.security.delegation.client.request.CallbackRequest;
import edu.uiuc.ncsa.security.delegation.client.request.CallbackResponse;
import edu.uiuc.ncsa.security.delegation.services.AddressableServer;
import edu.uiuc.ncsa.security.delegation.services.Request;
import edu.uiuc.ncsa.security.delegation.services.Response;

import java.net.URI;

/**
 * Clients that require a callback server should use this.
 * <p>Created by Jeff Gaynor<br>
 * on May 12, 2011 at  1:07:20 PM
 */
public abstract class CallbackServer implements AddressableServer {
    protected CallbackServer(URI address) {
        this.address = address;
    }

    URI address;

    public URI getAddress() {
        return address;
    }

    public Response process(Request request) {
        return request.process(this);
    }

    public abstract CallbackResponse processCallback(CallbackRequest callbackRequest);
}
