package edu.uiuc.ncsa.security.delegation.client.server;

import edu.uiuc.ncsa.security.delegation.client.request.ProtectedAssetRequest;
import edu.uiuc.ncsa.security.delegation.client.request.ProtectedAssetResponse;
import edu.uiuc.ncsa.security.delegation.services.AddressableServer;
import edu.uiuc.ncsa.security.delegation.services.Request;
import edu.uiuc.ncsa.security.delegation.services.Response;

import java.net.URI;

/**
 * Client-side modelling of a server that serves up protected resources.
 * <p>Created by Jeff Gaynor<br>
 * on Mar 11, 2011 at  4:10:00 PM
 */
public abstract class ResourceServer implements AddressableServer {
    protected ResourceServer(URI address) {
        this.address = address;
    }

    public URI getAddress() {
        return address;
    }

    URI address;

    public Response process(Request request) {
        return request.process(this);
    }

    public abstract ProtectedAssetResponse processProtectedAssetRequest(ProtectedAssetRequest request);
}
